/* NFIB  C code for comparison with TIGRE   NFIB.C */

#include <stdio.h>

#define  UNIX  1

#if UNIX
#include <sys/types.h>
#include <sys/times.h>
/* time measurement definitions */
#define	HZ	60
#define INT_32  int

#else   /* TURBOC time telling, etc. */
#include <time.h>
#include <stdlib.h>
#define	HZ	CLK_TCK
#define INT_32  long

#endif

#if UNIX
/* variables for time measurement: */
struct tms      time_info;
extern long     times (struct tms *time_info);
long            Begin_Time, End_Time;
#else
clock_t		Begin_Time, End_Time;
#endif
float           Seconds, Combinators_Per_Second;

/* ______________________________________________________________________ */

INT_32 nfib(INT_32 n)
{ INT_32 newn ;
  if ( n < 2 )
    { newn = 1 ;
      return(newn) ;
    }
  n = nfib(n-1) + nfib(n-2) + 1 ;
  return(n) ;
}

void main(int argc,char *argv[])
  { INT_32 result ;
   int inparam;
   printf("\nnfib timing program (in C)");

   inparam = 12345 ;
   while ( inparam > 0 )
   {
     printf("\nInput value (0 to stop)?");
     scanf("%d",&inparam);
     printf("input = %d\n",inparam);
     if(feof(stdin))  return ;
     if(inparam == 0) return ;

#if UNIX
       /* Start timer */
       times (&time_info);
       Begin_Time = (long) time_info.tms_utime;
#else
       Begin_Time = clock();
#endif
       /* Evaluate nfib */
       result = nfib(inparam);
#if UNIX
       /* Stop timer */
       times (&time_info);
       End_Time = (long) time_info.tms_utime;
#else
       End_Time = clock();
#endif
#if VAX
       printf("And the answer is.....%d   ",result);
#else
       printf("And the answer is.....%ld   ",result);
#endif

       /* compute elapsed time */
       Seconds = ((float) (End_Time - Begin_Time) ) / HZ ;
         printf ("\nElapsed time in seconds: %8.3f  ", Seconds);
       printf ("\n");

   }
   return;
  }
